void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->_TMP_ADD10_OUT,0,retain)
  __INIT_VAR(data__->_TMP_EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_SEL15_OUT,0,retain)
  __INIT_VAR(data__->_TMP_AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,_TMP_ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,_TMP_EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->_TMP_ADD10_OUT,)));
  __SET_VAR(data__->,_TMP_SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->_TMP_EQ13_OUT,),
    (UINT)__GET_VAR(data__->_TMP_ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->_TMP_SEL15_OUT,));
  __SET_VAR(data__->,_TMP_AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->_TMP_EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->_TMP_AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void INTERFACEOUT_init__(INTERFACEOUT *data__, BOOL retain) {
  __INIT_EXTERNAL(SIO,G_SIO,data__->G_SIO,retain)
  __INIT_VAR(data__->OUT_0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_5,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_6,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_7,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_8,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_9,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_10,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_11,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_12,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_13,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->OUT_14,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void INTERFACEOUT_body__(INTERFACEOUT *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->,OUT_0,,__GET_EXTERNAL(data__->G_SIO,.RY1));
  __SET_VAR(data__->,OUT_1,,__GET_EXTERNAL(data__->G_SIO,.RY2));
  __SET_VAR(data__->,OUT_2,,__GET_EXTERNAL(data__->G_SIO,.PL1));
  __SET_VAR(data__->,OUT_3,,__GET_EXTERNAL(data__->G_SIO,.PL2));
  __SET_VAR(data__->,OUT_4,,__GET_EXTERNAL(data__->G_SIO,.PL3));
  __SET_VAR(data__->,OUT_5,,__GET_EXTERNAL(data__->G_SIO,.PL4));
  __SET_VAR(data__->,OUT_6,,__GET_EXTERNAL(data__->G_SIO,.DP1));
  __SET_VAR(data__->,OUT_7,,__GET_EXTERNAL(data__->G_SIO,.DP2));
  __SET_VAR(data__->,OUT_8,,__GET_EXTERNAL(data__->G_SIO,.DP4));
  __SET_VAR(data__->,OUT_9,,__GET_EXTERNAL(data__->G_SIO,.DP8));
  __SET_VAR(data__->,OUT_10,,__GET_EXTERNAL(data__->G_SIO,.SPD0));
  __SET_VAR(data__->,OUT_11,,__GET_EXTERNAL(data__->G_SIO,.DP10));
  __SET_VAR(data__->,OUT_12,,__GET_EXTERNAL(data__->G_SIO,.DP20));
  __SET_VAR(data__->,OUT_13,,__GET_EXTERNAL(data__->G_SIO,.DP40));
  __SET_VAR(data__->,OUT_14,,__GET_EXTERNAL(data__->G_SIO,.DP80));

  goto __end;

__end:
  return;
} // INTERFACEOUT_body__() 





void CONVEROBJ_init__(CONVEROBJ *data__, BOOL retain) {
  __INIT_EXTERNAL(SCNV,G_SCNV,data__->G_SCNV,retain)
  __INIT_EXTERNAL(SMANU,G_SMANU,data__->G_SMANU,retain)
  __INIT_EXTERNAL(SIO,G_SIO,data__->G_SIO,retain)
}

// Code part
void CONVEROBJ_body__(CONVEROBJ *data__) {
  // Initialise TEMP variables

  __SET_EXTERNAL(data__->,G_SCNV,.LRUN,__GET_EXTERNAL(data__->G_SMANU,.RQCNVLEFT));
  __SET_EXTERNAL(data__->,G_SCNV,.RRUN,__GET_EXTERNAL(data__->G_SMANU,.RQCNVRIGHT));
  __SET_EXTERNAL(data__->,G_SCNV,.LSLEFT,__GET_EXTERNAL(data__->G_SIO,.LS2));
  __SET_EXTERNAL(data__->,G_SCNV,.LSRIGHT,__GET_EXTERNAL(data__->G_SIO,.LS1));
  __SET_EXTERNAL(data__->,G_SIO,.RY1,(__GET_EXTERNAL(data__->G_SCNV,.LRUN) && !(__GET_EXTERNAL(data__->G_SCNV,.LSLEFT))));
  __SET_EXTERNAL(data__->,G_SIO,.RY2,(__GET_EXTERNAL(data__->G_SCNV,.RRUN) && !(__GET_EXTERNAL(data__->G_SCNV,.LSRIGHT))));

  goto __end;

__end:
  return;
} // CONVEROBJ_body__() 





void LAMPOBJ_init__(LAMPOBJ *data__, BOOL retain) {
  __INIT_EXTERNAL(SIO,G_SIO,data__->G_SIO,retain)
  __INIT_EXTERNAL(SCNV,G_SCNV,data__->G_SCNV,retain)
  __INIT_VAR(data__->PLS1SEC,__BOOL_LITERAL(FALSE),retain)
  TON_init__(&data__->TON0,retain);
  __INIT_VAR(data__->FF1SEC,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->FFRES,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LAMPOBJ_body__(LAMPOBJ *data__) {
  // Initialise TEMP variables

  __SET_VAR(data__->TON0.,IN,,!(__GET_VAR(data__->PLS1SEC,)));
  __SET_VAR(data__->TON0.,PT,,__time_to_timespec(1, 1000, 0, 0, 0, 0));
  TON_body__(&data__->TON0);
  __SET_VAR(data__->,PLS1SEC,,__GET_VAR(data__->TON0.Q,));
  __SET_VAR(data__->,FFRES,,(__GET_VAR(data__->FF1SEC,) && __GET_VAR(data__->PLS1SEC,)));
  __SET_VAR(data__->,FF1SEC,,(!(__GET_VAR(data__->FFRES,)) && (__GET_VAR(data__->FF1SEC,) || __GET_VAR(data__->PLS1SEC,))));
  __SET_EXTERNAL(data__->,G_SIO,.PL1,(((__GET_EXTERNAL(data__->G_SCNV,.LSLEFT) && __GET_EXTERNAL(data__->G_SCNV,.LRUN)) && __GET_VAR(data__->FF1SEC,)) || (!(__GET_EXTERNAL(data__->G_SCNV,.LSLEFT)) && __GET_EXTERNAL(data__->G_SCNV,.LRUN))));
  __SET_EXTERNAL(data__->,G_SIO,.PL2,(((__GET_EXTERNAL(data__->G_SCNV,.LSRIGHT) && __GET_EXTERNAL(data__->G_SCNV,.RRUN)) && __GET_VAR(data__->FF1SEC,)) || (!(__GET_EXTERNAL(data__->G_SCNV,.LSRIGHT)) && __GET_EXTERNAL(data__->G_SCNV,.RRUN))));

  goto __end;

__end:
  return;
} // LAMPOBJ_body__() 





void INTERFACEIN_init__(INTERFACEIN *data__, BOOL retain) {
  __INIT_EXTERNAL(SIO,G_SIO,data__->G_SIO,retain)
  __INIT_VAR(data__->IN_0,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_5,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_6,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_7,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_8,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_9,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_10,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_11,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_12,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_13,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_14,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->IN_15,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void INTERFACEIN_body__(INTERFACEIN *data__) {
  // Initialise TEMP variables

  __SET_EXTERNAL(data__->,G_SIO,.LS1,__GET_VAR(data__->IN_0,));
  __SET_EXTERNAL(data__->,G_SIO,.LS2,__GET_VAR(data__->IN_1,));
  __SET_EXTERNAL(data__->,G_SIO,.LS3,__GET_VAR(data__->IN_2,));
  __SET_EXTERNAL(data__->,G_SIO,.LS4,__GET_VAR(data__->IN_3,));
  __SET_EXTERNAL(data__->,G_SIO,.LS5,__GET_VAR(data__->IN_4,));
  __SET_EXTERNAL(data__->,G_SIO,.PB1,__GET_VAR(data__->IN_5,));
  __SET_EXTERNAL(data__->,G_SIO,.PB2,__GET_VAR(data__->IN_6,));
  __SET_EXTERNAL(data__->,G_SIO,.PB3,__GET_VAR(data__->IN_7,));
  __SET_EXTERNAL(data__->,G_SIO,.PB4,__GET_VAR(data__->IN_8,));
  __SET_EXTERNAL(data__->,G_SIO,.PB5,__GET_VAR(data__->IN_9,));
  __SET_EXTERNAL(data__->,G_SIO,.SS1,__GET_VAR(data__->IN_10,));
  __SET_EXTERNAL(data__->,G_SIO,.SS0,__GET_VAR(data__->IN_11,));
  __SET_EXTERNAL(data__->,G_SIO,.DSW1,__GET_VAR(data__->IN_12,));
  __SET_EXTERNAL(data__->,G_SIO,.DSW2,__GET_VAR(data__->IN_13,));
  __SET_EXTERNAL(data__->,G_SIO,.DSW4,__GET_VAR(data__->IN_14,));
  __SET_EXTERNAL(data__->,G_SIO,.DSW8,__GET_VAR(data__->IN_15,));

  goto __end;

__end:
  return;
} // INTERFACEIN_body__() 





void MANUCONT_init__(MANUCONT *data__, BOOL retain) {
  __INIT_EXTERNAL(SMANU,G_SMANU,data__->G_SMANU,retain)
  __INIT_EXTERNAL(SIO,G_SIO,data__->G_SIO,retain)
}

// Code part
void MANUCONT_body__(MANUCONT *data__) {
  // Initialise TEMP variables

  __SET_EXTERNAL(data__->,G_SMANU,.RQCNVLEFT,__GET_EXTERNAL(data__->G_SIO,.PB1));
  __SET_EXTERNAL(data__->,G_SMANU,.RQCNVRIGHT,__GET_EXTERNAL(data__->G_SIO,.PB2));

  goto __end;

__end:
  return;
} // MANUCONT_body__() 





